﻿
/*----------------------------------------------------------------
 * Copyright (C) 2011 
 * 版权所有： 
 * 
 * 文件名：BinarySerialize.cs
 * 文件功能描述：二进制序列化方法
 *              
 *              
 * 创建标识：关泽文 2011-03-25
 * 
 * 修改标识：
 * 修改描述：
 * 
 * 
 * -----------------------------------------------------------------*/

using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows.Forms;
using System;
using System.Linq;
using System.Collections.Generic;
// Downloads By http://www.veryhuo.com
namespace ExpressionEditor
{
    /// <summary>
    /// 二进制序列化方法
    /// </summary>
    class BinarySerialize
    {
        /// <summary>
        /// 获取路径
        /// </summary>
        /// <param name="clsType"></param>
        /// <returns></returns>
        public static string GetPath(Type clsType)
        {
            return AppDomain.CurrentDomain.BaseDirectory + "" + clsType.Name + ".cond";
        }

        /// <summary>
        /// 获取模板集合
        /// </summary>
        /// <returns></returns>
        public static List<string> GetConds()
        {
            var _path = AppDomain.CurrentDomain.BaseDirectory;
            var _files = (from x1 in Directory.GetFiles(_path)
                          where Path.GetExtension(x1) == ".cond"
                          select x1).ToList();
            return _files;
        }

        /// <summary>
        /// 将实体序列化为文件
        /// </summary>
        /// <param name="inst"></param>
        /// <param name="filePath"></param>
        public static void Serialize(object inst, string filePath)
        {
            IFormatter _formatter = new BinaryFormatter();
            Stream _stream = new FileStream(filePath, FileMode.Create, FileAccess.Write, FileShare.None);
            _formatter.Serialize(_stream, inst);
            _stream.Close();
        }

        /// <summary>
        /// 将文件反序列化为实体
        /// </summary>
        /// <param name="filePath"></param>
        /// <returns></returns>
        public static object Deserialize(string filePath)
        {
            IFormatter _formatter = new BinaryFormatter();
            Stream _stream = new FileStream(filePath, FileMode.Open, FileAccess.Read, FileShare.Read);
            var _result = _formatter.Deserialize(_stream);
            _stream.Close();
            return _result;
        }
    }
}
