﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace ExpressionEditor.Sample
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }

        private void FrmMain_Load(object sender, EventArgs e)
        {
            treeView1.ExpandAll();
        }


        private void OpenSubForm(string title, string url)
        {
            if (!string.IsNullOrEmpty(url))
            {
                Cursor = Cursors.WaitCursor;
                Form _form = null;
                Dictionary<string, string> _params = new Dictionary<string, string>();
                var _type = GetFormType(url + "");
                foreach (var item in this.MdiChildren)
                {
                    if (item.GetType() == _type)
                    {
                        item.BringToFront();
                        Cursor = Cursors.Default;
                        return;
                    }
                }
                if (_type != null)
                {
                    _form = Activator.CreateInstance(_type) as Form;
                    _form.MdiParent = this;
                    _form.Dock = DockStyle.Fill;
                    _form.Show();
                }
                Cursor = Cursors.Default;
            }
        }

        /// <summary>
        /// 根据窗体名获取窗体的类型
        /// </summary>
        /// <param name="formTypeName"></param>
        /// <returns></returns>
        public static Type GetFormType(string formTypeName)
        {
            Type _formType = null;
            var _assembly = Assembly.GetExecutingAssembly();
            if (formTypeName.Contains(","))
            {
                var _arrParam = formTypeName.Split(new Char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                if (_arrParam.Length > 0)
                    _assembly = Assembly.Load(_arrParam[0]);
                if (_arrParam.Length > 1)
                {
                    if (!_arrParam[1].Contains("&"))
                        formTypeName = _arrParam[1];
                    else
                        formTypeName = _arrParam[1].Split('&')[0];
                }
            }
            _formType = _assembly.GetType(formTypeName);
            return _formType;
        }

        private void treeView1_DoubleClick(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode != null && treeView1.SelectedNode.Tag != null)
            {
                OpenSubForm(treeView1.SelectedNode.Text, treeView1.SelectedNode.Tag + "");
            }
        }
    }
}
